#include "squid.h"

/* is debugging turned on */
int opt_debug = 1;

/* global variable that points to the list of machines in the unit interval */
struct machplace *uiPtr = NULL;
/*global variable that points to the table of hosts */
struct hostinfo *tablePtr = NULL;

int main(){
  struct hostinfo *thisPtr;
  /* read the current file of  */
  readdump();
  thisPtr  = tablePtr;

  /* go through the host table and add the points for each machine */
  while (thisPtr != NULL) {
    dhGetMachinePoints(thisPtr->addr,3);
    thisPtr = thisPtr->nexthost;
  }
  dump();
  return 0;
}

/* get a number of points for a machine */
int 
dhGetMachinePoints(char *hostname, int points) {
  int f;
  int len = (int) strlen(hostname);
  /* 
  long init = crc32(hostname,len);
  dhSrand(init);

  for(f=0;f<points;f++) {
    unsigned int i = dhRand();
    double d = ((double)i) / ((double)DH_RAND_MAX);
    printf("%f\n",d);
    dhAddMachineToInterval(hostname,d);
  }
  return 0;
}


/* add a machine,point pair to the unit interval */
int 
dhAddMachineToInterval(char *hostname, double d ) {
  struct machplace *newmach, *lastPtr, *currPtr =uiPtr;

  while (currPtr != NULL) {

    /* save the current place for the next round */
    lastPtr = currPtr;

    /* deal with duplicates - they will happen eventually */
    if (currPtr->position == d) {
      int i;
      d = d + 0.000001;
      i = dhAddMachineToInterval(hostname,d);
      return i;
    }
    else if (currPtr->position > d) {

      /* malloc space for a new entry in the table */
      newmach = (struct machplace *) malloc(sizeof(struct machplace));
      if (newmach == NULL){
	perror("malloc");
	return(-1);
      }
      newmach->name = malloc(strlen(hostname) + 1);
      if (newmach->name == NULL) {
	perror("malloc");
	return(-1);
      }
      /* put the new address and time in the malloc'd space, and point the
       * entry's nexthost pointer to the beginning of the old table */
      strcpy(newmach->name,hostname);
      newmach->position = d;
      newmach->nextmach =  currPtr;

      lastPtr->nextmach = newmach;

      return(0);
    }
    currPtr = currPtr->nextmach;
  }
  /* this should never be reached. */
  return -1;
}


/* find the nearest machine to any point on the unit interval */
struct machplace *
dhFindNearestMachine(double point) {
  struct machplace *lastPtr, *currPtr =uiPtr;

  while (currPtr != NULL) {

    /* save the current place for the next round */
    lastPtr = currPtr;

    if (currPtr->position >= point) {
      double upper, lower;
      upper = currPtr->position - point;
      lower = lastPtr->position - point;
      if (upper > lower) {
	return lastPtr;
      }
      else {
	return currPtr;
      }
   
    }
  }
  return lastPtr;
}
